unit hiCopyFileWithProgress;

interface

uses Kol,windows,Share,Debug,MMSystem;

{ functionCopyFileEx(lpExistingFileName, lpNewFileName: PChar; lpProgressRoutine: TFNProgressRoutine; lpData: Pointer; pbCancel: PBool; dwCopyFlags: DWORD): BOOL;

:
lpExistingFileName, lpNewFileName:    , .

lpProgressRoutine       :  Callback   nil.     ,     . . CopyProgressRoutine.  CopyProgressRoutine    WinNT;

lpData :   Callback .    nil.

pbCancel:    .        ,     .

dwCopyFlags:  ,    :
COPY_FILE_FAIL_IF_EXISTS -    ,    .
COPY_FILE_RESTARTABLE - ,       ,      ,   lpExistingFileName, lpNewFileName         .

 :
0   .  GetLastError    . }


{procedure THIFileSearch._var_Size;
type T=record L,H:integer end;
var FSize:int64;
begin
  T(FSize).L := FindData.nFileSizeLow;
  T(FSize).H := FindData.nFileSizeHigh;
  if (T(FSize).H=0)and(T(FSize).L>=0) then dtInteger(_Data,T(FSize).L)
  else dtReal(_Data,FSize);
end;}


const RES_OK = 0;

type   //      
  TCallbackProgress = packed record
    POPEDX: Byte;
    MOVEAX: Byte;
    SelfPtr: Pointer;
    PUSHEAX: Byte;
    PUSHEDX: Byte;
    JMP: Byte;
    JmpOffset: Integer;
  end;

type
  TCallMMTimer = packed record
    POPEDX: Byte;
    MOVEAX: Byte;
    SelfPtr: Pointer;
    PUSHEAX: Byte;
    PUSHEDX: Byte;
    JMP: Byte;
    JmpOffset: Integer;
  end;

type //     
   TClock = packed record
     sec,min,hrs:byte;
   end;

type
  TVarStop = packed record
    InfoRealTime:TClock;  //    
    InfoEndTime:TClock;   // 
    RealTime:integer;     // -    
    BitSec:Int64;         //     
    FileSize:Int64;       //  
    FilesSize:Int64;      //   
    DataSize:Int64;       //     .   copy/move
    Cancelled:boolean;    //   
    FLS:PStrList;         //    ( )
    FLD:PStrList;         //    ( )
    Position:integer;     //  / 
    Position1:integer;    //   / 

    Path:string;
    timetmp:integer;

  end;

type
  THICopyFileWithProgress = class(TDebug)
   private
    FTimer:PTimer;         //    
    fInfoRealTime:TClock;  //    
    fInfoEndTime:TClock;   // 
    fRealTime:integer;     // -    
    fBitSec:Int64;         //     
    fFileSize:Int64;       //  
    fFilesSize:Int64;      //   
    fDataSize:Int64;       //     .   copy/move
    fCancelled:boolean;    //   
    fFLS:PStrList;         //    ( )
    fFLD:PStrList;         //    ( )
    fPosition:integer;     //  / 
    fPosition1:integer;    //   / 

    fPath:string;
    ftimetmp:integer;

    Callback: TCallbackProgress; //    
    CallbackMMT: TCallMMTimer;

    fVarStop:TVarStop;     //   

    procedure OnTimer(Obj:PObj);

    procedure MMTCallback(TimerID, Msg: Uint; dwUser, dw1, dw2: DWORD); stdcall;
    function CopyFileWithProgressBar(TotalFileSize,
                                     TotalBytesTransferred,
                                     StreamSize,
                                     StreamBytesTransferred: LARGE_INTEGER;
                                     dwStreamNumber,
                                     dwCallbackReason: DWORD;
                                     hSourceFile,
                                     hDestinationFile: THandle;
                                     lpData: Pointer): DWORD; stdcall;

   public
    old_bs,new_bs:Int64;

    sSource, sDest: string;
    mmt:integer;

    _prop_Rewrite:boolean;
    _prop_Count:integer;

    _data_Dest:THI_Event;
    _data_Source:THI_Event;
    _event_onError:THI_Event;
    _event_onCount:THI_Event;
    _event_onPosition:THI_Event;
    _event_onFullPosition:THI_Event;
    _event_onInfoSize:THI_Event;
    _event_onInfoName:THI_Event;
    _event_onInfoTime:THI_Event;
    _event_onEnd:THI_Event;

    constructor Create;
    destructor Destroy; override;
    procedure StopOperation;
    procedure InfoTime(var time: string);
    procedure CalcEndTime(var itime:integer; var stime: string);
    procedure _work_doCopyFiles(var _Data:TData; Index:word);
    procedure _work_doMoveFiles(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    procedure _work_doCopyDir(var _Data:TData; Index:word);
  end;

implementation

//   
function GetFileSize(const FileName: string): Int64;
type Int64Rec = record Lo,Hi:integer end;
var
  Handle: THandle;
  FindData: TWin32FindData;
begin
  Handle := FindFirstFile(PChar(FileName), FindData);
  if Handle <> INVALID_HANDLE_VALUE then begin
    Windows.FindClose(Handle);
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
    begin
      Int64Rec(Result).Lo := FindData.nFileSizeLow;
      Int64Rec(Result).Hi := FindData.nFileSizeHigh;
      Exit;
    end;
  end;
  Result := -1;
end;


//  ,   / 
function BytesToStr(const i64Size: Int64): string;
const
   i64GB = (1024 * 1024) * 1024;
   i64MB = 1024 * 1024;
   i64KB = 1024;
begin
   if i64Size div i64GB > 0 then
     Result := Double2str(round(i64Size/i64GB/0.01)*0.01)+' Gb'
   else if i64Size div i64MB > 0 then
     Result := Double2str(round(i64Size/i64MB/0.01)*0.01)+' Mb'
   else if i64Size div i64KB > 0 then
     Result := Double2str(round(i64Size/i64KB/0.01)*0.01)+' Kb'
   else
     Result := Int2Str(i64Size) + ' Byte(s)';
end;

constructor THICopyFileWithProgress.Create;
begin
  inherited  Create;
   FTimer := NewTimer(1000);
   FTimer.Enabled := false;
   FTimer.OnTimer := onTimer;
  //     
  Callback.POPEDX := $5A;
  Callback.MOVEAX := $B8;
  Callback.SelfPtr := Self;
  Callback.PUSHEAX := $50;
  Callback.PUSHEDX := $52;
  Callback.JMP := $E9;
  Callback.JmpOffset := Integer(@THICopyFileWithProgress.CopyFileWithProgressBar) -
                                 Integer(@Callback.JMP) - 5;

  mmt := 0;

  CallbackMMT.POPEDX := $5A;
  CallbackMMT.MOVEAX := $B8;
  CallbackMMT.SelfPtr := Self;
  CallbackMMT.PUSHEAX := $50;
  CallbackMMT.PUSHEDX := $52;
  CallbackMMT.JMP := $E9;
  CallbackMMT.JmpOffset := Integer(@THICopyFileWithProgress.MMTCallback) -
                                    Integer(@CallbackMMT.JMP) - 5;


  //  
  fFLS := NewStrList;
  fFLD := NewStrList;
  //    
  fInfoRealTime.sec := 0;
  fInfoRealTime.min := 0;
  fInfoRealTime.hrs := 0;
  fInfoEndTime.sec := 0;
  fInfoEndTime.min := 0;
  fInfoEndTime.hrs := 0;
  fRealTime := 0;

end;

destructor THICopyFileWithProgress.Destroy;
begin
{$ifndef F_P}
  FTimer.Free;
{$endif}
  //  ,   
  fFLS.Free;
  fFLD.Free;
  inherited
end;

//    . 
function FormatInd(i:integer): string;
begin
  case i of
   0..9: begin Result := '0'+ int2str(i); end;
  else  Result := int2str(i);
  end;
end;

//      
procedure THICopyFileWithProgress.CalcEndTime(var itime:integer; var stime: string);
const iMIN = 60; iHRS = (60 * 60);
var s,m,h:integer;
begin
  h := Round(itime / iHRS);
  m := Round(itime / iMIN) mod 60;
  s := Round(itime) mod 60;
  stime := FormatInd(h) + ':' +
           FormatInd(m) + ':' +
           FormatInd(s);
end;

//   
procedure THICopyFileWithProgress.InfoTime(var time: string);
var stmp:string; itmp,t:integer;
begin
  inc(fRealTime);
  inc (fInfoRealTime.sec);
  case fInfoRealTime.sec of
    60: begin fInfoRealTime.sec := 0; inc(fInfoRealTime.min) end;
  end;
  case fInfoRealTime.min of
    60: begin fInfoRealTime.min := 0; inc(fInfoRealTime.hrs) end;
  end;
  case fInfoRealTime.hrs of
    24: fInfoRealTime.hrs := 0;
  end;

  //    
  itmp := 100 - ftimetmp;
  itmp := round ((fRealTime / 100) * itmp);
  CalcEndTime(itmp,stmp);

  //   
  //     
  time := FormatInd(fInfoRealTime.hrs) + ':' +
          FormatInd(fInfoRealTime.min) + ':' +
          FormatInd(fInfoRealTime.sec) + ';' + stmp;
end;

//        
procedure THICopyFileWithProgress.MMTCallback;
var t: string;
begin
  fBitSec := (old_bs - new_bs)*-1;
  InfoTime(t);
  _hi_onEvent(_event_onInfoTime, BytesToStr(fBitSec) + '/sec' + ';' + t);
  old_bs := new_bs;
end;

procedure THICopyFileWithProgress.onTimer;
begin

end;

procedure THICopyFileWithProgress.StopOperation;
begin
  with fVarStop do
  begin
    InfoRealTime :=   fInfoRealTime;
    InfoEndTime  :=   fInfoEndTime;
    RealTime     :=   fRealTime;
    BitSec       :=   fBitSec;
    FileSize     :=   fFileSize;
    FilesSize    :=   fFilesSize;
    DataSize     :=   fDataSize;
    Cancelled    :=   fCancelled;
    //FLS          :=   fFLS;
    //FLD          :=   fFLD;
    Position     :=   fPosition;
    Position1    :=   fPosition1;
  end;

end;

function THICopyFileWithProgress.CopyFileWithProgressBar;
var pos,pos1: LONGLONG;
    fTmp:Int64;
begin

  //if dwCallbackReason = CALLBACK_CHUNK_FINISHED then
  //end;

  //   ,    . 
  //    onFullPosition
  if dwCallbackReason = CALLBACK_STREAM_SWITCH then  begin
    fFileSize := TotalFileSize.QuadPart;
    fDataSize := fDataSize + (TotalFileSize.QuadPart - TotalBytesTransferred.QuadPart);
  end;

  //    onPosition   (0-100)
  if (TotalBytesTransferred.QuadPart > 0) and (TotalFileSize.QuadPart > 0) then
  begin
     pos  := Round((TotalBytesTransferred.QuadPart / TotalFileSize.QuadPart)*100);
     //if dwCallbackReason = CALLBACK_CHUNK_FINISHED then begin
     ftmp := fDataSize;
     fDataSize := (fDataSize + TotalBytesTransferred.QuadPart) - TotalFileSize.QuadPart;
     //  .      
     new_bs := fDataSize;
     pos1 := Round((fDataSize / fFilesSize)*100);
     //      
     ftimetmp := pos1;
     _hi_onEvent(_event_onFullPosition, pos1);

    //   onInfoSize    ;
    //  ,    
    //   ,    
     _hi_onEvent(_event_onInfoSize, BytesToStr(fFileSize) +
                 ';' + BytesToStr(TotalBytesTransferred.QuadPart)+
                 ';' + BytesToStr(fFilesSize) +
                 ';' + BytesToStr(fDataSize));

     fDataSize := ftmp;
    //     
     _hi_onEvent(_event_onPosition, pos);
     //end;
  end;

  //   :)
  Applet.ProcessMessages;
  Result := PROGRESS_CONTINUE;
end;


procedure THICopyFileWithProgress._work_doCopyFiles;
var  Err,i,j: integer;
     tmp,s,d: string;
     dh: HDC;
begin
  //   / 
  fFLS.SetText(ReadString(_Data, _data_Source, ''),false);
  fFLD.SetText(ReadString(_Data, _data_Dest, ''),false);

  //   
  j := fFLS.Count-1;

  //       
  if fFLS.Count <> fFLD.Count then
  begin
  //    
    _hi_onEvent( _event_onError, 'Error:   ');
    exit;
  //     
  end else begin
    for i := 0 to j do begin
      tmp := fFLS.Items[i];
      fFilesSize := fFilesSize + GetFileSize(tmp);
    end;
  end;
  //    
  dh := CreateCompatibleDC(0);

  //   
  fCancelled := False;
  //  
  //FTimer.Enabled := True;
  mmt := TimeSetEvent(1000, 0, @CallbackMMT, DWORD(Self),
                      TIME_PERIODIC or TIME_CALLBACK_FUNCTION);

  //_debug(_prop_Count);

  //    
  for i := 0 to j do begin
  //     
    sSource := fFLS.Items[i];
    sDest := fFLD.Items[i];
    //   
    s := MinimizeName(sSource,dh,_prop_Count);
    d := MinimizeName(sDest,dh,_prop_Count);
    fPath := ExtractFilePath(sDest);
  //  in/out    onInfoName
  //  _hi_onEvent(_event_onInfoName, sSource + ';' + sDest);
  _hi_onEvent(_event_onInfoName, s + ';' + d);
    if not DirectoryExists(fPath) then ForceDirectories(fPath);
  //  
    if not CopyFileEx(PChar(sSource), PChar(sDest), @Callback,
                  nil, @FCancelled, COPY_FILE_RESTARTABLE) then
  //      onError
    begin
      Err := GetLastError;
      _hi_onEvent( _event_onError, 'Error code number: ' + Int2Str(Err));
      exit;
    end;
  end;
  //_Debug('end');
  //FTimer.Enabled := False;
  TimeKillEvent(mmt); mmt := 0;
  _hi_onEvent(_event_onEnd, '');
end;

procedure THICopyFileWithProgress._work_doMoveFiles;
begin

end;

procedure THICopyFileWithProgress._work_doStop;
var f: integer;
begin
  f := ToInteger(_Data);
  //   
  case f of
    0: begin fCancelled := True; TimeKillEvent(mmt); mmt := 0; end;
    1: fCancelled := False;
  end;
end;

procedure THICopyFileWithProgress._work_doCopyDir;
var i: integer; s: string;
begin
 i := ToInteger(_Data);
 CalcEndTime(i,s);
end;

end.
